Bug 1231693 - Silent ABI change breaks obconf and etc
Summary: Silent ABI change breaks obconf and etc
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: openbox
Version: 22
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Miroslav Lichvar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-06-15 09:06 UTC by Mamoru TASAKA
Modified: 2015-07-14 15:51 UTC (History)
2 users (show)

Fixed In Version: openbox-3.6-3.fc22
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-07-14 15:51:11 UTC
Type: Bug


Attachments (Terms of Use)
gdb log (5.54 KB, text/plain)
2015-06-15 09:06 UTC, Mamoru TASAKA
no flags Details

Description Mamoru TASAKA 2015-06-15 09:06:37 UTC
Created attachment 1038842 [details]
gdb log

Description of problem:
On F-22 and above, just launching
$ obconf
causes obconf segfault.
gdb log attached.

$ lxappearance
also just segfaults

Version-Release number of selected component (if applicable):
openbox-3.6-1.fc22.x86_64
obconf-2.0.4-4.fc22.x86_64
lxappearance-obconf-0.2.0-6.fc22.x86_64


How reproducible:
100%

Steps to Reproduce:
1. See above
2.
3.

Actual results:
See attached gdb log

Comment 1 Mamoru TASAKA 2015-06-15 09:09:15 UTC
After debugging it turned out that this is because
openbox changed struct RrTheme between 3.5.2 and 3.6, but no soversion
bump happened, so it broke applications using struct RrTheme silently.

$ diff -up ./f21/openbox-3.5.2/obrender/theme.h ./master/openbox-3.6/obrender/theme.h
--- ./f21/openbox-3.5.2/obrender/theme.h	2013-08-12 10:33:24.000000000 +0900
+++ ./master/openbox-3.6/obrender/theme.h	2015-01-13 04:48:27.000000000 +0900
@@ -76,16 +76,16 @@ struct _RrTheme {
     RrColor *cb_unfocused_color;
     RrColor *title_focused_color;
     RrColor *title_unfocused_color;
-    RrColor *titlebut_disabled_focused_color;
-    RrColor *titlebut_disabled_unfocused_color;
-    RrColor *titlebut_hover_focused_color;
-    RrColor *titlebut_hover_unfocused_color;
-    RrColor *titlebut_toggled_hover_focused_color;
-    RrColor *titlebut_toggled_hover_unfocused_color;
-    RrColor *titlebut_toggled_focused_pressed_color;
-    RrColor *titlebut_toggled_unfocused_pressed_color;
-    RrColor *titlebut_toggled_focused_unpressed_color;
-    RrColor *titlebut_toggled_unfocused_unpressed_color;
+    RrColor *titlebut_focused_disabled_color;
+    RrColor *titlebut_unfocused_disabled_color;
+    RrColor *titlebut_focused_hover_color;
+    RrColor *titlebut_unfocused_hover_color;
+    RrColor *titlebut_focused_hover_toggled_color;
+    RrColor *titlebut_unfocused_hover_toggled_color;
+    RrColor *titlebut_focused_pressed_toggled_color;
+    RrColor *titlebut_unfocused_pressed_toggled_color;
+    RrColor *titlebut_focused_unpressed_toggled_color;
+    RrColor *titlebut_unfocused_unpressed_toggled_color;
     RrColor *titlebut_focused_pressed_color;
     RrColor *titlebut_unfocused_pressed_color;
     RrColor *titlebut_focused_unpressed_color;
@@ -114,15 +114,7 @@ struct _RrTheme {
     RrColor *osd_pressed_lineart;
     RrColor *osd_focused_lineart;
     RrColor *menu_title_shadow_color;
-    gchar    menu_title_shadow_alpha;
-    RrColor *menu_text_normal_shadow_color;
-    gchar    menu_text_normal_shadow_alpha;
-    RrColor *menu_text_selected_shadow_color;
-    gchar    menu_text_selected_shadow_alpha;
-    RrColor *menu_text_disabled_shadow_color;
-    gchar    menu_text_disabled_shadow_alpha;
-    RrColor *menu_text_disabled_selected_shadow_color;
-    gchar    menu_text_disabled_selected_shadow_alpha;
+    RrColor *menu_text_shadow_color;
 
     /* style settings - pics */
     RrPixel32 *def_win_icon; /* RGBA */

Comment 2 Mamoru TASAKA 2015-06-15 09:10:25 UTC
repoquery shows that only
* obconf
* lxappearance-obconf

depends on openbox-libs (other than openbox), the above 2 packages need
rebuilding.

Comment 3 Miroslav Lichvar 2015-06-15 09:19:40 UTC
Thanks for the report. Fortunately, the update didn't hit stable yet.

https://admin.fedoraproject.org/updates/FEDORA-2015-9341/openbox-3.6-1.fc22

When obconf and lxappearance-obconf are ready we can add them to the update.

Comment 4 Mamoru TASAKA 2015-06-15 10:28:25 UTC
Note that I have confirmed that just rebuilding the above 2 packages
against openbox (3.6) made both working properly.

Comment 5 Miroslav Lichvar 2015-06-15 10:49:17 UTC
Upstream discussion:

http://icculus.org/pipermail/openbox/2015-June/008870.html

Comment 6 Miroslav Lichvar 2015-06-25 15:48:50 UTC
I've added a padding to the header to make libobrender compatible again, obconf and lxappearance-obconf don't need to be recompiled.

Comment 7 Fedora Update System 2015-06-25 15:56:37 UTC
openbox-3.6-3.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/openbox-3.6-3.fc22

Comment 8 Fedora Update System 2015-06-26 06:39:09 UTC
Package openbox-3.6-3.fc22:
* should fix your issue,
* was pushed to the Fedora 22 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openbox-3.6-3.fc22'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-10732/openbox-3.6-3.fc22
then log in and leave karma (feedback).

Comment 9 Fedora Update System 2015-07-14 15:51:11 UTC
openbox-3.6-3.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.